﻿UseSQLiteDatabase()
Enumeration
  #tl ;title list
  #tn ; title name
  #tc ; title content
  #tf ; note find
  #ba ; button add
  #bd ; button delete
EndEnumeration

Enumeration
  #menu_add
  #menu_quit
EndEnumeration

Global dbname.s="notes.db3"
Global notenum.l

Procedure udb(sql.s)
  If OpenDatabase(1, dbname,#NULL$,#NULL$)
    ;sql.s="insert into aneks(anek) values('"+I$+"')"
    If DatabaseUpdate(1, sql)
    Else
      MessageRequester("Error", "Can't execute the query: "+DatabaseError())
    EndIf
    CloseDatabase(1)
  EndIf
EndProcedure

Procedure initdb()
  If FileSize(dbname)=-1
    CreateFile(2, dbname)
    CloseFile(2)
    
    If OpenDatabase(1, dbname,#NULL$,#NULL$)
      udb("create table notes(noteid integer PRIMARY KEY, ntitle text, ncont text);")
    EndIf
  EndIf
EndProcedure

Procedure refreshnotelist()
  notenum=-1
  If OpenDatabase(1, dbname,#NULL$,#NULL$)
    ClearGadgetItems(#tl)
    np.l=0
;select *from notes where ntitle like 'n%' order by ntitle
    sql.s="select * from notes";  order by ntitle"
    fl.s=ReplaceString(GetGadgetText(#tf),"'","''")
    If fl<>""
      sql=sql+" where ntitle like '"+fl+"%'"
    EndIf
    sql+" order by ntitle"

    If DatabaseQuery(1, sql)
      While NextDatabaseRow(1)
        AddGadgetItem(#tl, np, GetDatabaseString(1,1))
        ;        nind=GetDatabaseLong(1,0)
        SetGadgetItemData( #tl, np, GetDatabaseLong(1,0) )
        np+1
      Wend
      FinishDatabaseQuery(1)
      CloseDatabase(1)
    Else
      MessageRequester("Error", "Can't execute the query: "+DatabaseError())
    EndIf
  EndIf
  
EndProcedure

Procedure addnote()
  notet.s=FormatDate("%yyyy.%mm.%dd,%hh:%ii:%ss", Date())
  udb("insert into notes(ntitle,ncont) values('"+notet+"','');")
  SetGadgetText(#tn,"")
  SetGadgetText(#tc,"")
  refreshnotelist()
  ;notenum=-1
EndProcedure

If OpenWindow(0, 0, 0, 640, 480, "My notes 0.9", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget|#PB_Window_Invisible)
  ListViewGadget(#tl, 0, 0, 150, 440)
  StringGadget(#tn, 152,  0, 488, 20, ""):GadgetToolTip(#tn,"Note Title")
  StringGadget(#tc, 152,  20, 488, 440, "",#ES_MULTILINE|#ES_AUTOVSCROLL|#WS_VSCROLL|#WS_HSCROLL|#ESB_DISABLE_LEFT|#ESB_DISABLE_RIGHT)
  GadgetToolTip(#tc,"Note Content")
  StringGadget(#tf, 0,  440, 150, 20, ""):GadgetToolTip(#tf,"Note Filter")
  ButtonGadget(#ba,0,460,20,20,"+"):GadgetToolTip(#ba,"Add record")
  ButtonGadget(#bd,20,460,20,20,"-"):GadgetToolTip(#bd,"Delete record")
  
  hicon.l=LoadIcon_(GetModuleHandle_(0),1)
  AddSysTrayIcon(0, WindowID(0), hicon)
  
  CreatePopupMenu(0)
  MenuItem(#menu_add, "Show Window")
  MenuItem(#menu_quit, "Quit")
  
  ;HideWindow(0,0)
  
  initdb()
  refreshnotelist()
  ;notenum=-1
  ;   For a = 1 To 12
  ;     AddGadgetItem (#tl, -1, "Item " + Str(a) + " of the Listview") ; define listview content
  ;   Next
  ;   SetGadgetState(#tl, 9) ; set (beginning with 0) the tenth item as the active one
  Repeat 
    ev.l=WaitWindowEvent()
    Select ev
      Case #PB_Event_SysTray
        If EventType()=#PB_EventType_RightClick
          DisplayPopupMenu(0,WindowID(0))
        EndIf
        
      Case #PB_Event_CloseWindow
        HideWindow(0,1)
      Case #PB_Event_Menu
        Select EventMenu()
          Case #menu_add
            ;addnote()
            HideWindow(0,0)
            
          Case #menu_quit:Break
        EndSelect
        
        
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #tn,#tc
            If EventType()=#PB_EventType_Change And notenum<>-1
              notet.s=ReplaceString(GetGadgetText(#tn),"'","''")
              notec.s=ReplaceString(GetGadgetText(#tc),"'","''")
              udb("update notes set ntitle='"+notet+"',ncont='"+notec+"' where noteid="+Str(notenum)+";")
              
              nn.l=notenum
              refreshnotelist()
              notenum=nn
            EndIf
          Case #tf
            If EventType()=#PB_EventType_Change
              refreshnotelist()
              ;notenum=-1
            EndIf
          Case #tl
            If EventType()=#PB_EventType_LeftClick
              cl.l=GetGadgetState(#tl)
              If cl<>-1
                notenum.l=GetGadgetItemData(#tl,cl)
                
                If OpenDatabase(1, dbname,#NULL$,#NULL$)
                  sql.s="select * from notes where noteid="+Str(notenum)
                  If DatabaseQuery(1, sql)
                    While NextDatabaseRow(1)
                      SetGadgetText(#tn,GetDatabaseString(1,1))
                      SetGadgetText(#tc,GetDatabaseString(1,2))
                    Wend
                    FinishDatabaseQuery(1)
                    CloseDatabase(1)
                  Else
                    MessageRequester("Error", "Can't execute the query: "+DatabaseError())
                  EndIf
                EndIf
                
              Else
                notenum=-1
              EndIf
            EndIf
          Case #bd
            cl=GetGadgetState(#tl)
            If cl<>-1
              notenum=GetGadgetItemData(#tl,cl)
              udb("delete from notes where noteid="+Str(notenum)+";")
              SetGadgetText(#tn,"")
              SetGadgetText(#tc,"")
              refreshnotelist()
              ;notenum=-1
              
            EndIf
          Case #ba
            addnote()
            ;             notet.s=FormatDate("%yyyy.%mm.%dd,%hh:%ii:%ss", Date())
            ;             udb("insert into notes(ntitle,ncont) values('"+notet+"','');")
            ;             SetGadgetText(#tn,"")
            ;             SetGadgetText(#tc,"")
            ;             refreshnotelist()
            ;             notenum=-1
        EndSelect
        
    EndSelect
    
  ForEver;ev = #PB_Event_CloseWindow
  RemoveSysTrayIcon(0)
EndIf


; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 94
; FirstLine = 76
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = notes02.ico
; Executable = mn.exe